-----------------------------------------------------------------Initiate
----Init Variables
-- the map
map = {
"a                      a     a",
"a                      a     a",
"a           aaaaaaa    a     a",
"a           a     a   aa     a",
"a           a     a    a     a",
"a                 a          a",
"a                 a          a",
"a   aaaaaaaaaa   aaaaaaaaaaaaa",
"a                            a",
"a                            a",
"a   aaaaaaaaaaaaaaaaaaaaaa   a",
"a   aa           bb     bd   a",
"a   aa           bb     b    a",
"a   aa         aaaa   aaaaaaaa",
"a                            a",
"a                            a",
"abbbbbbbbbbbbbbbbbbbbbbbbbbbba",
}
map2 =  {
"a                      a     a",
"a                      a     a",
"a           aaaaaaa    a     a",
"a           a     a   aa     a",
"a           a     a    a     a",
"a                 a          a",
"a                 a          a",
"aaaaaaaaaaaaaa   aaaaaaaaaaaaa",
"a                            a",
"a                            a",
"a   aaaaaaaaaaaaaaaaaaaaaa   a",
"a   aa                       a",
"a   aa                       a",
"a   aa         aaaa   aaaaaaaa",
"a                            a",
"a                            a",
"a                            a",
}
Music.playFile("phendrana.xm",true)
--Music.volume(60)
background=Image.load("background3.png")
exitX=430
exitY=230
playerX = 410
playerY = 40
tiles=Image.load("blocktile3.png")
nxt="item1.lua"
prev="boss1.lua"
enemy={x=16,y=224,ani=0,dir=0,maxy=430,miny=16,dead=0}



----Functions:

function collision(x1, y1, w1, h1, x2, y2, w2, h2)
  if (y2 >= y1 and y1 + h1 >= y2) or (y2 + h2 >= y1 and y1 + h1 >= y2 + h2) or (y1 >= y2 and y2 + h2 >= y1) or (y1 + h1 >= y2 and y2 + h2 >= y1 + h1) then
    if x2 >= x1 and x1 + w1 >= x2 then
    return true
    elseif x2 + w2 >= x1 and x1 + w1 >= x2 + w2 then
    return true
    elseif x1 >= x2 and x2 + w2 >= x1 then
    return true
    elseif x1 + w1 >= x2 and x2 + w2 >= x1 + w1 then
    return true
    end
  end

return false
end




canjump=true

----resources:
lives=3
green = Color.new(0,100,0)
red = Color.new(200,0,0)
blue = Color.new(0,0,200)
white = Color.new(200,200,200)


sprlives=Image.load("lives.png")
orb=Image.load("orb.png")
sndjump= Sound.load("jump.wav")
sndchime= Sound.load("chime.wav")
sprexit=Image.load("exit.png")
sprkey=Image.load("key.png")
sndbling= Sound.load("bling.wav")
sprenemy=Image.load("enemy.png")
orbshock=Image.load("orbshock.png")

sndzap= Sound.load("zap.wav")
snddie= Sound.load ("lose.wav")
shock=0





screen:clear()




-- offsreen image, where the map will be drawn
board = Image.createEmpty(480, 272)
board:blit(0,0, background,  false)


 function drawTile(tile, x, y)
  local tileX = math.mod(tile, 4)
  local tileY = math.floor(tile /4)

  board:blit(16 * x, 16 * y, tiles, 16 * tileX , 16 * tileY, 16, 16,false)
  
end
kv=0
n=0
local keyX = {}
local keyY = {}

local solidX = {}
local solidY = {}

  for y = 1, 17 do
    line = map[y]
    for x = 1, 30 do
          tile = string.byte(line, x) - string.byte("a")
        
      if tile == 0 or tile == 1 or tile == 2  then
      n=n+1      
      solidX[n] = (x-1)*16
      solidY[n] = (y-1)*16
      drawTile(tile, x - 1, y - 1)

      end
      if tile == 3 then
      kv=kv+1
      board:blit((x-1)*16 ,(y-1)*16 , sprkey)
      keyX[kv] = (x-1)*16
      keyY[kv] = (y-1)*16
      end

    end

end
v=n
kk=kv

-- current player and objects position
playerXstart =playerX
playerYstart =playerY
vspeed=0
k=0 
-- current player animation image
animation = 0
eanimation = 0 
-- 1 = animation images increases, -1: decreases
animationDirection = 1

-- animation slowdown counter
animationSlowDown = 0
z=0

---------------------------------------------------------------------------Main loop


while true do
----------------------------------Gravity and Collision Detection and friction and block detection

if k == 0 then
for kv = 1,kk  do

if  collision(playerX, playerY,32,32,keyX[kv],keyY[kv],16,29)  then
--local solidX = {}
--local solidY = {}
n=0
kv=kk
board = Image.createEmpty(480, 272)
board:blit(0,0, background,  false)

sndbling:play()


  for y = 1, 17 do
    line = map2[y]
    for x = 1, 30 do
      tile = string.byte(line, x) - string.byte("a")
      drawTile(tile, x - 1, y - 1)
      
      if tile == 0 or tile == 2  then
      n=n+1      
      solidX[n] = (x-1)*16
      solidY[n] = (y-1)*16
      
      end
 
    end

end
k=1
v=n
end
end
end



if  collision(playerX, playerY,32,32,0,-1,480,0)  then
  vspeed=0
end
if  collision(playerX, playerY,32,32,0,272,480,1)  then
lives=lives-1
snddie:play()
screen.waitVblankStart(90)
playerX =playerXstart
playerY =playerYstart



end
if  collision(playerX, playerY,32,32,enemy.x,enemy.y,32,32)  then

if(shock==1)then
if(enemy.dead==0)then
snddie:play()
enemy.dead=1
end
end


if(shock==0)then
if(enemy.dead==0)then
lives=lives-1
snddie:play()
screen.waitVblankStart(90)
playerX =playerXstart
playerY =playerYstart
end
end

end


if lives == 0 then
screen:clear()
    screen:print(20,110,"You lost all your lives and must go back a level.", white);
  screen:flip()

screen.waitVblankStart(120)

dofile(prev)
end


g=1
m=0
for n = 1,v  do
m=m+1
if  collision(playerX, playerY+30,32,1,solidX[n],solidY[n], 16,16)  then
  vspeed=0
  
  canjump=true
  g=2
  elseif m == v and  g == 1 then
    canjump=false
      vspeed=vspeed + 0.5
  
  
end



end

if(shock==0)then
if vspeed <= -12 then
vspeed=-12
end

if vspeed >= 12 then
vspeed=12
end
end

if(shock==1)then
if vspeed <= -7 then
vspeed=-7
end

if vspeed >= 12 then
vspeed=12
end
end


for n = 1,v  do

 if  collision(playerX, playerY+4,32,26,solidX[n],solidY[n], 16,16)  then
  vspeed=0
playerY=prevY
end
end



------------------------------------controls
pad = Controls.read()


if pad:select() then
Music.stop()

dofile("script.lua")



end

if pad:left() then
m=0
gl=1
for n = 1,v  do
m=m+1
  if collision(playerX-4, playerY+4,32,26, solidX[n],solidY[n], 16,16) then
  gl=2
 

  elseif m == v and  gl == 1 then
  playerX=playerX-4
  end
end
end


if pad:right() then
m=0
gr=1
for n = 1,v  do
m=m+1

  if collision(playerX+4, playerY+4, 32,26,solidX[n],solidY[n], 16,16)  then
  gr=2

  elseif m == v and  gr == 1 then
  playerX=playerX+4  
  end
end
end

if pad:cross() then

  if  canjump == true then
  sndjump:play()
  vspeed=-10
end  
end


if pad:square() then

sndzap:play()
shock=1
else
shock=0
end

if pad:up() then

  if  canjump == true then
  sndjump:play()
  vspeed=-10
end  
end

if collision(playerX, playerY, 32,32,exitX,exitY, 40,40)  then
--Music.stop()
sndchime:play()
screen.waitVblankStart(90)
dofile(nxt)

end


if(enemy.dead==0)then
if(enemy.x<=enemy.miny)then
enemy.dir=0
end
if(enemy.x>=enemy.maxy)then
enemy.dir=1
end

if(enemy.dir==0)then
enemy.x=enemy.x+4
end
if(enemy.dir==1)then
enemy.x=enemy.x-4
end
end

prevX=playerX
prevY=playerY
if(shock==1)then
playerY=playerY+vspeed/2
end
if(shock==0)then
playerY=playerY+vspeed
end
------------------------------------------Draw Images:
screen:clear()




  screen:blit(0, 0, board, 0, 0, board:width(), board:height(), false)

   --String_Display = "string.byte(b): " .. string.byte("c");
    --screen:print(20, 10, String_Display, red);



  -- calculate next animation image
  animationSlowDown = animationSlowDown + 1

  -- blit current player animation image
if(shock==1)then
  Image:blit(playerX , playerY, orbshock, 32 * animation, 0, 32, 32,true)

  if animationSlowDown == 3 then
   
    animation = animation + animationDirection
    if animation == 6 then
      animation = 0
    
    end
  end
end
if(shock==0)then
  Image:blit(playerX , playerY, orb, 32 * animation, 0, 32, 32,true)

  if animationSlowDown == 3 then
   
    animation = animation + animationDirection
    if animation == 6 then
      animation = 0
    
    end
  end
end

  -- blit current exit animation image
  Image:blit(exitX , exitY, sprexit, 40 * eanimation, 0, 40, 39,true)
  
  -- calculate next animation image

  if animationSlowDown == 3 then
    eanimation = eanimation + animationDirection
    if eanimation == 12 then
      eanimation = 0
    
    end

end

if(enemy.dead==0)then
  Image:blit(enemy.x , enemy.y, sprenemy, 32 * enemy.ani, 0, 32, 32,true)

  -- calculate next animation image
  if animationSlowDown == 3 then
 animationSlowDown = 0
    enemy.ani = enemy.ani + animationDirection
    if enemy.ani == 6 then
      enemy.ani = 0
    
    end
  end
end

  if animationSlowDown == 3 then
 animationSlowDown = 0
end
  Image:blit(10,4, sprlives, 0, 0, 85, 20,true)

   String_Display = lives;
    screen:print(70, 10, String_Display, red);
screen.waitVblankStart()
  screen:flip()
end
